import React, {Component} from "react";
import './Icon.scss';

interface IconProps {
    name: string;
    width: number;
    height: number;
    color?: string;
}

export class Icon extends Component<IconProps> {

    render() {
        let {name, width, height, color} = this.props;
        let overrides = {};

        if (color) {
            overrides = {color};
        }

        switch (name) {
            case 'console':
                return (
                    <svg className="icon" xmlns="http://www.w3.org/2000/svg" version="1.1"
                         width={width} height={height} viewBox="0 0 471.362 471.362">
                        <g>
                            <g>
                                <path
                                    d="M468.794,355.171c-1.707-1.718-3.897-2.57-6.563-2.57H188.145c-2.664,0-4.854,0.853-6.567,2.57    c-1.711,1.711-2.565,3.897-2.565,6.563v18.274c0,2.662,0.854,4.853,2.565,6.563c1.713,1.712,3.903,2.57,6.567,2.57h274.086    c2.666,0,4.856-0.858,6.563-2.57c1.711-1.711,2.567-3.901,2.567-6.563v-18.274C471.365,359.068,470.513,356.882,468.794,355.171z"
                                    style={overrides}/>
                                <path
                                    d="M30.259,85.075c-1.903-1.903-4.093-2.856-6.567-2.856s-4.661,0.953-6.563,2.856L2.852,99.353    C0.95,101.255,0,103.442,0,105.918c0,2.478,0.95,4.664,2.852,6.567L115.06,224.69L2.852,336.896C0.95,338.799,0,340.989,0,343.46    c0,2.478,0.95,4.665,2.852,6.567l14.276,14.273c1.903,1.906,4.089,2.854,6.563,2.854s4.665-0.951,6.567-2.854l133.048-133.045    c1.903-1.902,2.853-4.096,2.853-6.57c0-2.473-0.95-4.663-2.853-6.565L30.259,85.075z"
                                    style={overrides}/>
                            </g>
                        </g>

                    </svg>
                );
            case 'shown':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M8 3C4.36364 3 1.23636 5.27333 0 8.5C1.23636 11.7267 4.36364 14 8 14C11.6364 14 14.7636 11.7267 16 8.5C14.7636 5.27333 11.6364 3 8 3ZM8 12.1667C5.96364 12.1667 4.36364 10.5533 4.36364 8.5C4.36364 6.44667 5.96364 4.83333 8 4.83333C10.0364 4.83333 11.6364 6.44667 11.6364 8.5C11.6364 10.5533 10.0364 12.1667 8 12.1667ZM8 6.3C6.76364 6.3 5.81818 7.25333 5.81818 8.5C5.81818 9.74667 6.76364 10.7 8 10.7C9.23636 10.7 10.1818 9.74667 10.1818 8.5C10.1818 7.25333 9.23636 6.3 8 6.3Z"
                              style={overrides}/>
                    </svg>
                );
            case 'hidden':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <g clipPath="url(#clip0)">
                            <path
                                d="M7.87664 6.27278L10.1821 8.57096C10.1821 8.53459 10.1821 8.49096 10.1821 8.45459C10.1821 7.87594 9.95223 7.32098 9.54306 6.91181C9.13389 6.50264 8.57893 6.27278 8.00028 6.27278C7.95664 6.27278 7.92028 6.27278 7.87664 6.27278ZM4.74909 6.94545L5.87636 8.07273C5.84 8.22545 5.81818 8.37818 5.81818 8.54545C5.81818 9.12411 6.04805 9.67906 6.45722 10.0882C6.86639 10.4974 7.42135 10.7273 8 10.7273C8.16 10.7273 8.32 10.7055 8.47273 10.6691L9.6 11.7964C9.11273 12.0364 8.57455 12.1818 8 12.1818C7.03558 12.1818 6.11065 11.7987 5.4287 11.1168C4.74675 10.4348 4.36364 9.50988 4.36364 8.54545C4.36364 7.97091 4.50909 7.43273 4.74909 6.94545ZM0.727273 2.92364L2.38545 4.58182L2.71273 4.90909C1.51273 5.85455 0.567273 7.09091 0 8.54545C1.25818 11.7382 4.36364 14 8 14C9.12727 14 10.2036 13.7818 11.1855 13.3891L11.4982 13.6945L13.6218 15.8182L14.5455 14.8945L1.65091 2L0.727273 2.92364ZM8.00028 4.81823C8.9647 4.81823 9.88963 5.20135 10.5716 5.8833C11.2535 6.56525 11.6366 7.49017 11.6366 8.45459C11.6366 8.92005 11.5421 9.37096 11.3748 9.77823L13.5057 11.9091C14.5966 11 15.4694 9.80732 16.0003 8.45459C14.7421 5.26187 11.6366 3.00005 8.00028 3.00005C6.9821 3.00005 6.00755 3.18187 5.09119 3.50914L6.66937 5.07277C7.08392 4.91277 7.52755 4.81823 8.00028 4.81823Z"
                                style={overrides}/>
                        </g>
                        <defs>
                            <clipPath id="clip0">
                                <path d="M0 0H16V16H0V0Z" fill="white"/>
                            </clipPath>
                        </defs>
                    </svg>
                );
            case 'copy':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M12.6673 14.0001H5.33398V4.66675H12.6673V14.0001ZM12.6673 3.33341H5.33398C4.98036 3.33341 4.64122 3.47389 4.39118 3.72394C4.14113 3.97399 4.00065 4.31313 4.00065 4.66675V14.0001C4.00065 14.3537 4.14113 14.6928 4.39118 14.9429C4.64122 15.1929 4.98036 15.3334 5.33398 15.3334H12.6673C13.0209 15.3334 13.3601 15.1929 13.6101 14.9429C13.8602 14.6928 14.0007 14.3537 14.0007 14.0001V4.66675C14.0007 4.31313 13.8602 3.97399 13.6101 3.72394C13.3601 3.47389 13.0209 3.33341 12.6673 3.33341ZM10.6673 0.666748H2.66732C2.3137 0.666748 1.97456 0.807224 1.72451 1.05727C1.47446 1.30732 1.33398 1.64646 1.33398 2.00008V11.3334H2.66732V2.00008H10.6673V0.666748Z"
                            style={overrides}/>
                    </svg>
                );
            case 'select':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M10.4382 5.53577L7.01374 8.9569L5.52607 7.47067L4.78223 8.21378L7.01374 10.4431L11.182 6.27888L10.4382 5.53577Z"
                            style={overrides}/>
                    </svg>
                )
            case 'edit':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M11.334 4.66671H14.6673V11.3334H11.334V12.6667C11.334 12.8435 11.4042 13.0131 11.5292 13.1381C11.6543 13.2631 11.8238 13.3334 12.0007 13.3334H13.334V14.6667H11.6673C11.3007 14.6667 10.6673 14.3667 10.6673 14C10.6673 14.3667 10.034 14.6667 9.66732 14.6667H8.00065V13.3334H9.33398C9.5108 13.3334 9.68036 13.2631 9.80539 13.1381C9.93041 13.0131 10.0007 12.8435 10.0007 12.6667V3.33337C10.0007 3.15656 9.93041 2.98699 9.80539 2.86197C9.68036 2.73695 9.5108 2.66671 9.33398 2.66671H8.00065V1.33337H9.66732C10.034 1.33337 10.6673 1.63337 10.6673 2.00004C10.6673 1.63337 11.3007 1.33337 11.6673 1.33337H13.334V2.66671H12.0007C11.8238 2.66671 11.6543 2.73695 11.5292 2.86197C11.4042 2.98699 11.334 3.15656 11.334 3.33337V4.66671ZM1.33398 4.66671H8.66732V6.00004H2.66732V10H8.66732V11.3334H1.33398V4.66671ZM13.334 10V6.00004H11.334V10H13.334Z"
                            style={overrides}/>
                    </svg>
                );
            case 'focus':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M7.3 1V2.449C4.766 2.771 2.771 4.766 2.449 7.3H1V8.7H2.449C2.771 11.234 4.766 13.229 7.3 13.551V15H8.7V13.551C11.234 13.229 13.229 11.234 13.551 8.7H15V7.3H13.551C13.229 4.766 11.234 2.771 8.7 2.449V1H7.3ZM7.3 3.856V5.2H8.7V3.863C10.45 4.15 11.85 5.55 12.144 7.3H10.8V8.7H12.137C11.85 10.45 10.45 11.85 8.7 12.144V10.8H7.3V12.137C5.55 11.85 4.15 10.45 3.856 8.7H5.2V7.3H3.863C4.15 5.55 5.55 4.15 7.3 3.856ZM7.125 8C7.125 7.51675 7.51675 7.125 8 7.125C8.48325 7.125 8.875 7.51675 8.875 8C8.875 8.48325 8.48325 8.875 8 8.875C7.51675 8.875 7.125 8.48325 7.125 8Z"
                              style={overrides}/>
                    </svg>
                );
            case 'delete':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M10.5 2.85714H13V4.57143H3V2.85714H5.5L6.33333 2H9.66667L10.5 2.85714ZM10.5 14H5.5C4.57953 14 3.83333 13.2325 3.83333 12.2857V5.42857H12.1667V12.2857C12.1667 13.2325 11.4205 14 10.5 14Z"
                              style={overrides}/>
                    </svg>
                );
            case 'line':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M2.79289 17.7929C3.18342 18.1834 3.81658 18.1834 4.20711 17.7929L9.5 12.5L13.5 16.5L21.3781 7.62095C21.7277 7.22687 21.7109 6.62889 21.3397 6.25504C20.9336 5.84606 20.2665 5.86498 19.8843 6.29631L13.5 13.5L9.5 9.5L2.70711 16.2929C2.31658 16.6834 2.31658 17.3166 2.70711 17.7071L2.79289 17.7929Z"
                            style={overrides}/>
                    </svg>
                );
            case 'stickyLine':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M21 7.71429C21 8.65714 20.19 9.42857 19.2 9.42857C19.038 9.42857 18.885 9.41143 18.741 9.36857L16.437 13.2686C16.482 13.4057 16.5 13.56 16.5 13.7143C16.5 14.6571 15.69 15.4286 14.7 15.4286C13.71 15.4286 12.9 14.6571 12.9 13.7143C12.9 13.56 12.918 13.4057 12.963 13.2686L10.668 11.0829C10.524 11.1257 10.362 11.1429 10.2 11.1429C10.038 11.1429 9.876 11.1257 9.732 11.0829L6.537 15.8486C6.582 15.9857 6.6 16.1314 6.6 16.2857C6.6 17.2286 5.79 18 4.8 18C3.81 18 3 17.2286 3 16.2857C3 15.3429 3.81 14.5714 4.8 14.5714C4.962 14.5714 5.115 14.5886 5.259 14.6314L8.463 9.87429C8.418 9.73714 8.4 9.58286 8.4 9.42857C8.4 8.48571 9.21 7.71429 10.2 7.71429C11.19 7.71429 12 8.48571 12 9.42857C12 9.58286 11.982 9.73714 11.937 9.87429L14.232 12.06C14.376 12.0171 14.538 12 14.7 12C14.862 12 15.024 12.0171 15.168 12.06L17.463 8.15143C17.418 8.01429 17.4 7.86857 17.4 7.71429C17.4 6.77143 18.21 6 19.2 6C20.19 6 21 6.77143 21 7.71429Z"
                            style={overrides}/>
                    </svg>
                );
            case 'point':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M12 8.5C11.0717 8.5 10.1815 8.86875 9.52513 9.52513C8.86875 10.1815 8.5 11.0717 8.5 12C8.5 12.9283 8.86875 13.8185 9.52513 14.4749C10.1815 15.1313 11.0717 15.5 12 15.5C12.9283 15.5 13.8185 15.1313 14.4749 14.4749C15.1313 13.8185 15.5 12.9283 15.5 12C15.5 11.0717 15.1313 10.1815 14.4749 9.52513C13.8185 8.86875 12.9283 8.5 12 8.5Z"
                            style={overrides}/>
                    </svg>
                );
            case 'stickyPoint':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M4 11C3.44772 11 3 11.4477 3 12C3 12.5523 3.44772 13 4 13H8.64589C8.8105 13.5521 9.1104 14.0601 9.52513 14.4749C10.1815 15.1313 11.0717 15.5 12 15.5C12.9283 15.5 13.8185 15.1313 14.4749 14.4749C14.8896 14.0601 15.1895 13.5521 15.3541 13H20C20.5523 13 21 12.5523 21 12C21 11.4477 20.5523 11 20 11H15.3541C15.1895 10.4479 14.8896 9.93985 14.4749 9.52513C13.8185 8.86875 12.9283 8.5 12 8.5C11.0717 8.5 10.1815 8.86875 9.52513 9.52513C9.1104 9.93985 8.8105 10.4479 8.64589 11H4Z"
                              style={overrides}/>
                    </svg>
                );
            case 'polygon':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M11.4995 5.16325C11.7977 4.94558 12.2023 4.94558 12.5005 5.16325L18.6516 9.65353C18.948 9.86992 19.0718 10.2523 18.9584 10.6014L16.6226 17.7933C16.509 18.1431 16.183 18.38 15.8152 18.38H8.18478C7.81698 18.38 7.49102 18.1431 7.37741 17.7933L5.04157 10.6014C4.9282 10.2523 5.052 9.86992 5.34843 9.65353L11.4995 5.16325Z"
                              style={overrides}/>
                    </svg>
                );
            case 'rect':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M8 6C6.89543 6 6 6.89543 6 8V16C6 17.1046 6.89543 18 8 18H16C17.1046 18 18 17.1046 18 16V8C18 6.89543 17.1046 6 16 6H8Z"
                              style={overrides}/>
                    </svg>
                );
            case 'scene':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M5 9.5L7.5 14H2.5L5 9.5ZM3 4H7V8H3V4ZM5 20C5.53043 20 6.03914 19.7893 6.41421 19.4142C6.78929 19.0391 7 18.5304 7 18C7 17.4696 6.78929 16.9609 6.41421 16.5858C6.03914 16.2107 5.53043 16 5 16C4.46957 16 3.96086 16.2107 3.58579 16.5858C3.21071 16.9609 3 17.4696 3 18C3 18.5304 3.21071 19.0391 3.58579 19.4142C3.96086 19.7893 4.46957 20 5 20ZM9 5V7H21V5H9ZM9 19H21V17H9V19ZM9 13H21V11H9V13Z"
                            style={overrides}/>
                    </svg>
                );
            case 'source':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M12.8901 3L14.8501 3.4L11.1101 21L9.15008 20.6L12.8901 3ZM19.5901 12L16.0001 8.41V5.58L22.4201 12L16.0001 18.41V15.58L19.5901 12ZM1.58008 12L8.00008 5.58V8.41L4.41008 12L8.00008 15.58V18.41L1.58008 12Z"
                            style={overrides}/>
                    </svg>
                );
            case 'transparent':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 24 24" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path
                            d="M10.1933 18H12.08L18 12.08V10.1933L10.1933 18ZM16.6667 18C17.0333 18 17.3667 17.8533 17.6067 17.6067C17.8533 17.3667 18 17.0333 18 16.6667V15.3333L15.3333 18H16.6667ZM7.33333 6C6.97971 6 6.64057 6.14048 6.39052 6.39052C6.14048 6.64057 6 6.97971 6 7.33333V8.66667L8.66667 6H7.33333ZM11.92 6L6 11.92V13.8067L13.8067 6H11.92ZM17 6.05333L6.05333 17C6.11333 17.2333 6.23333 17.44 6.39333 17.6067C6.56 17.7667 6.76667 17.8867 7 17.9467L17.9533 7C17.8267 6.53333 17.4667 6.17333 17 6.05333Z"
                            fill="#8495AC" fillOpacity="0.7"/>
                    </svg>

                );
            case 'plus':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M13.6004 8.80002H8.80039V13.6H7.20039V8.80002H2.40039V7.20002H7.20039V2.40002H8.80039V7.20002H13.6004V8.80002Z"
                              style={overrides}/>
                    </svg>
                );
            case 'minus':
                return (
                    <svg className="icon" width={width} height={height} viewBox="0 0 16 16" fill="none"
                         xmlns="http://www.w3.org/2000/svg">
                        <path fillRule="evenodd" clipRule="evenodd"
                              d="M8.80039 8.79995H7.20039H2.40039V7.19995H7.20039H8.80039H13.6004V8.79995H8.80039Z"
                              style={overrides}/>
                    </svg>
                )
        }

    }
}